=== debian/changelog ===
ros-melodic-dccomms-ros (0.0.3-1bionic) bionic; urgency=high



 -- Diego Centelles <centelld@uji.es>  Sat, 14 Mar 2020 23:00:00 -0000

ros-melodic-dccomms-ros (0.0.2-1bionic) bionic; urgency=high



 -- Diego Centelles <centelld@uji.es>  Fri, 15 Nov 2019 23:00:00 -0000

ros-melodic-dccomms-ros (0.0.1-1bionic) bionic; urgency=high



 -- Diego Centelles <centelld@uji.es>  Sat, 09 Nov 2019 23:00:00 -0000
