=== debian/control ===
Source: ros-melodic-dccomms-ros
Section: misc
Priority: extra
Maintainer: Diego Centelles <centelld@uji.es>
Build-Depends: debhelper (>= 9.0.0), git, ros-melodic-actionlib, ros-melodic-actionlib-msgs, ros-melodic-catkin, ros-melodic-dccomms-ros-msgs, ros-melodic-message-generation, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-std-msgs, ros-melodic-tf
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-dccomms-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, git, ros-melodic-actionlib, ros-melodic-actionlib-msgs, ros-melodic-dccomms-ros-msgs, ros-melodic-message-runtime, ros-melodic-roscpp, ros-melodic-rospy, ros-melodic-std-msgs, ros-melodic-tf
Description: The dccomms_ros package
